#
# spec file for package ghc-yarr
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name yarr
Name:           ghc-%{pkg_name}
Version:        1.4.0.2
Release:        2.39
Summary:        Yet another array library
License:        MIT
Group:          Development/Languages/Other
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-fixed-vector-devel
BuildRequires:  ghc-missing-foreign-devel
BuildRequires:  ghc-primitive-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-template-haskell-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Yarr is a new blazing fast dataflow framework (array library), mainly intented
to process 'Storable's (including all "primitive" numeric types) and
'fixed-vector's of them, for example coordinates, color components, complex
numbers.

Yarr framework is inspired by 'repa' library and inherits its features,
including shape-polymorphism and auto-parallelism. Additionaly, the framework
is polymorphic over type and arity of fixed-size vectors and supports neat flow
operations over them. For example, you can convert colored image to greyscale
like this:

> let greyImage = zipElems (r g b -> 0.21 * r + 0.71 * g + 0.07 * b) image

In some cases the library is considerably faster than 'repa'. See benchmark
results: <https://github.com/leventov/yarr/blob/master/tests/bench-results.md>

Shortcoming by design: lack of pure indexing interface.

To start with, read documentation in the root module: "Data.Yarr".

['Yarr!'].

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%doc changelog.md

%changelog
* Thu Sep 15 2016 psimons@suse.com
- Update to version 1.4.0.2 revision 0 with cabal2obs.
